-----------------------------------------------------------------------------
-- Frequency counter.
--
-- Will document more later...
--
-- No really, I promise.
--
-- Ilya Belopolski
-- 14 June, 2010
-----------------------------------------------------------------------------

library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity CountFrequency is port
    (
    CLK : in std_logic;
    PPS : in std_logic;
    RF : in std_logic;
    FREQ : out std_logic_vector (31 downto 0);
    VALID : out std_logic
--    Give_oldRF : out std_logic;
--    Give_newRF : out std_logic;
--    Give_oldPPS : out std_logic;
--    Give_newPPS : out std_logic;
--    RF_out : out std_logic;
--    Give_frequency : out unsigned (31 downto 0)
    );
end entity CountFrequency;

architecture ark of CountFrequency is

     signal oldPPS : std_logic := '0';
     signal oldoldPPS : std_logic := '0';
     signal newPPS : std_logic := '0';

     signal counter : unsigned (31 downto 0) := (others => '0');
     signal frequency : unsigned (31 downto 0) := (others => '0');

     signal oldPPS_CLK : std_logic_vector (7 downto 0) := X"00";
     signal newPPS_CLK : std_logic := '0';
     signal freqfreq : std_logic_vector (31 downto 0) := (others => '0');

begin

     -- Synchronize the PPS signal with the RF signal.
     syncPPS : process (oldPPS, PPS) is
     begin
          if oldPPS = '1' then
             newPPS <= '0';
          elsif rising_edge (PPS) then
             newPPS <= '1';
          end if;
     end process syncPPS;

     oldPPS <= newPPS when rising_edge (RF);
     oldoldPPS <= oldPPS when rising_edge (RF);

--     Give_oldPPS <= oldPPS;
--     Give_newPPS <= newPPS;

     -- Count the frequency of the RF signal.
     freqOut : process (RF, oldPPS) is
     begin
          if rising_edge (RF) then
             if oldPPS = '1' then
                 counter <= X"00000001";
                 frequency <= counter;
             else
                 counter <= counter + 1;
             end if;
          end if;
     end process freqOut;

--     Give_frequency <= frequency;

     -- Synchronize the PPS signal with the CLK signal.
     syncRF : process (oldPPS_CLK, oldoldPPS) is
     begin
          if oldPPS_CLK(0) = '1' then
             newPPS_CLK <= '0';
          elsif rising_edge (oldoldPPS) then
             newPPS_CLK <= '1';
          end if;
     end process syncRF;

--     Give_oldRF <= oldPPS_CLK;
--     Give_newRF <= newPPS_CLK;

     oldPPS_CLK(7 downto 1) <= oldPPS_CLK (6 downto 0) when rising_edge (CLK);
     oldPPS_CLK(0) <= newPPS_CLK when rising_edge (CLK);

     -- Return the frequency.
     readOut : process (oldPPS_CLK, CLK) is
     begin
          if rising_edge (CLK) then
             -- Delay is require to guarantee that frequency is available
             -- There is no timing constraint between frequency and freqfreq!
             if oldPPS_CLK(7) = '1' then
                freqfreq <= std_logic_vector (frequency);
             end if;
          end if;
     end process readOut;

     FREQ <= freqfreq;
     VALID <= oldPPS_CLK(7) when rising_edge (CLK);

end architecture ark;
